<template>
    <div >
        <div class="wishlist">
            <a href="/manage-wishlist" v-if="userId">{{wishlistLinkLabel}}</a>
        </div>
        <div class="container mt-2" v-if="isCatalogView">
            <div class="row">
                <div class="col-md-12">
                    <h2 class="align-left border-bottom">Products</h2>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6 align-left ">
                    <span v-if="totalProducts">Found Products {{totalProducts}}</span>
                </div>
                <div class="col-md-6">
                    <select name="sort" v-model="sortBy" @change="sortAppliancesBy(sortBy)" id="price-sort" class="custom-select">
                        <optgroup label="Order by Price" data-collapsible-optgroup= "true" data-load-collapse-optgroup ="true">
                            <option value="price_asc">Price low to high</option>
                            <option value="price_desc">Price high to low</option>
                        </optgroup>
                        <optgroup label="Order by Title" data-collapsible-optgroup= "true" data-load-collapse-optgroup ="false">
                            <option value="title_asc">Ascending (A - Z)</option>
                            <option value="title_desc">Descending (Z - A)</option>
                        </optgroup>
                    </select>
                </div>
            </div>
            <products
                :products-data="productsData"
                :user-id="userId"
                :wishlist-data="wishlistData"
                :wishlist-user-id="wishlistUserId"
                :is-wish-list-catalog="isWishListCatalog"
            >
            </products>
        </div>
        <div class="product-details" v-else>
            <div class="container mt-4">
                <div class="row mb-4">
                    <a class="btn btn-light btn-sm" href @click.prevent="switchToCatalog"> < Back To Catalog</a>
                </div>
                <section>
                    <div class="row">
                        <div class="col-md-8 col-sm">
                            <div class="row" v-if="currentProduct.title">
                                <h3 class='name'>{{ currentProduct.title }}</h3>
                            </div>
                            <div class="row">
                                <div class="col-md-12" v-if="currentProduct.gallery_images">
                                    <carousel :per-page="1"  :mouse-drag=true>
                                        <slide v-for="galleryImage in currentProduct.gallery_images ">
                                            <img :src="galleryImage" style="height: 100%;">
                                        </slide>
                                    </carousel>
                                </div>
                            </div>
                            <div class="row mt-3 py-3 border-top">
                                <div class="col" v-for="product_detail in currentProduct.product_detail" v-html="product_detail">
                                </div>
                            </div>

                        </div>
                        <div class="col-md-4 col-sm">
                            <div class="row" v-if="currentProduct.title_image">
                                <div class="col">
                                    <img  class="m-3" width="140" :src="currentProduct.title_image">
                                </div>
                            </div>
                            <div class="row" v-if="currentProduct.price_discount">
                                <h1  class="col text-success font-weight-bold">
                                    <svg class="svg-icon-price-product green" viewBox="0 0 289.01202392578125 402.0111083984375" >
                                        <path d="M279.007 335.992l10.005 45.998c0 2.673-.348 4.67-1.004 6-1.34 2.673-3 4.004-4.997 4.004l-2.007.994c-.665 0-1.669.348-3 1.003-1.34 0-2.673.348-4.004 1.004-.665 0-1.669.348-3 1.003-1.34.666-2.345 1.004-3 1.004-1.34 0-2.846.174-4.495.502-1.669.348-2.846.502-3.502.502-.665 0-1.843.174-3.502.502-1.669.348-3.174.502-4.495.502-1.34.665-3 1.168-4.997 1.495-1.997.348-3.666.502-4.997.502-4.004 0-7.342.348-10.005 1.004h-10.998c-44 0-82.995-12.33-117.002-36.997-33.34-25.334-56.002-59.003-68.004-100.997H9.001c-2.673 0-4.997-1.004-7.004-3-1.34-1.331-1.997-3.328-1.997-6v-32c0-1.997.656-4.332 1.997-7.004 1.331-1.331 3.656-1.997 7.004-1.997h18.995c-1.34-11.325-1.34-21.33 0-30.003H9.001c-2.673 0-4.997-1.004-7.004-3C.657 178.36 0 176.016 0 174.009v-32c0-1.997.656-4.332 1.997-7.004 2.652-1.331 4.997-1.997 7.004-1.997h27.996c12.656-39.332 35.656-71.66 68.997-97.004C139.991 12.002 178.319 0 220.989 0c19.333 0 37.653 1.997 55 6 2.651 1.342 4.658 2.673 6 4.005.654 1.997 1.003 4.342 1.003 7.004l-12 45.998c-1.342 2.673-2.674 4.342-4.005 4.997-2.673 1.997-4.997 2.345-7.004 1.003h-2.007c-1.34-.656-2.345-1.003-3-1.003L249.979 67c-1.34 0-3.348-.327-6-1.003-2.673-.656-5.346-1.004-7.997-1.004-1.997 0-4.669-.327-7.997-1.003h-7.997c-24.003 0-45.67 6-65.004 18.002-19.344 13.343-33.669 30.34-42.998 50.995h134.001c2.652 0 4.997 1.004 7.004 3s2.652 4.67 1.997 7.998l-7.004 32c-1.34 5.345-4.342 7.998-9 7.998h-138.98c-1.34 7.342-1.34 17.346 0 30.003h131c2.652 0 4.997 1.003 7.004 3 1.331 1.34 1.997 4.004 1.997 7.997l-7.004 32c-1.34 2.673-2.345 4.342-3 4.997-2.673 1.34-4.669 1.997-6 1.997h-111c10.66 22.672 24.995 40.346 42.997 53.002 19.333 13.342 41.001 19.998 65.004 19.998 4.66 0 8.325-.327 10.998-1.003 4.004 0 7.004-.327 9.001-1.004.655 0 1.997-.154 4.004-.502 1.997-.327 3.655-.502 4.997-.502.655 0 1.833-.154 3.502-.502 1.66-.327 2.826-.502 3.502-.502.655 0 1.495-.327 2.5-1.003 1.003-.656 1.832-1.004 2.498-1.004l3-1.003h1.997c1.997-1.331 4.332-1.331 7.004 0 2.007 1.382 3.655 3.389 5.008 6.04z"></path>
                                    </svg>
                                    {{ currentProduct.price_discount }}
                                </h1>
                            </div>
                            <div class="row" v-if="currentProduct.price_previous">
                                <h2 class="col text-muted font-weight-bold">
                                    <del  class="align-text-top">
                                        <svg class="svg-icon-prev-price-product grey" viewBox="0 0 289.01202392578125 402.0111083984375" >
                                            <path d="M279.007 335.992l10.005 45.998c0 2.673-.348 4.67-1.004 6-1.34 2.673-3 4.004-4.997 4.004l-2.007.994c-.665 0-1.669.348-3 1.003-1.34 0-2.673.348-4.004 1.004-.665 0-1.669.348-3 1.003-1.34.666-2.345 1.004-3 1.004-1.34 0-2.846.174-4.495.502-1.669.348-2.846.502-3.502.502-.665 0-1.843.174-3.502.502-1.669.348-3.174.502-4.495.502-1.34.665-3 1.168-4.997 1.495-1.997.348-3.666.502-4.997.502-4.004 0-7.342.348-10.005 1.004h-10.998c-44 0-82.995-12.33-117.002-36.997-33.34-25.334-56.002-59.003-68.004-100.997H9.001c-2.673 0-4.997-1.004-7.004-3-1.34-1.331-1.997-3.328-1.997-6v-32c0-1.997.656-4.332 1.997-7.004 1.331-1.331 3.656-1.997 7.004-1.997h18.995c-1.34-11.325-1.34-21.33 0-30.003H9.001c-2.673 0-4.997-1.004-7.004-3C.657 178.36 0 176.016 0 174.009v-32c0-1.997.656-4.332 1.997-7.004 2.652-1.331 4.997-1.997 7.004-1.997h27.996c12.656-39.332 35.656-71.66 68.997-97.004C139.991 12.002 178.319 0 220.989 0c19.333 0 37.653 1.997 55 6 2.651 1.342 4.658 2.673 6 4.005.654 1.997 1.003 4.342 1.003 7.004l-12 45.998c-1.342 2.673-2.674 4.342-4.005 4.997-2.673 1.997-4.997 2.345-7.004 1.003h-2.007c-1.34-.656-2.345-1.003-3-1.003L249.979 67c-1.34 0-3.348-.327-6-1.003-2.673-.656-5.346-1.004-7.997-1.004-1.997 0-4.669-.327-7.997-1.003h-7.997c-24.003 0-45.67 6-65.004 18.002-19.344 13.343-33.669 30.34-42.998 50.995h134.001c2.652 0 4.997 1.004 7.004 3s2.652 4.67 1.997 7.998l-7.004 32c-1.34 5.345-4.342 7.998-9 7.998h-138.98c-1.34 7.342-1.34 17.346 0 30.003h131c2.652 0 4.997 1.003 7.004 3 1.331 1.34 1.997 4.004 1.997 7.997l-7.004 32c-1.34 2.673-2.345 4.342-3 4.997-2.673 1.34-4.669 1.997-6 1.997h-111c10.66 22.672 24.995 40.346 42.997 53.002 19.333 13.342 41.001 19.998 65.004 19.998 4.66 0 8.325-.327 10.998-1.003 4.004 0 7.004-.327 9.001-1.004.655 0 1.997-.154 4.004-.502 1.997-.327 3.655-.502 4.997-.502.655 0 1.833-.154 3.502-.502 1.66-.327 2.826-.502 3.502-.502.655 0 1.495-.327 2.5-1.003 1.003-.656 1.832-1.004 2.498-1.004l3-1.003h1.997c1.997-1.331 4.332-1.331 7.004 0 2.007 1.382 3.655 3.389 5.008 6.04z"></path>
                                        </svg>
                                        {{ currentProduct.price_previous }}
                                    </del>
                                </h2>
                            </div>
                            <wishlist
                                    :user-id="userId"
                                    :product="currentProduct"
                                    :wishlist-data="wishlistData"
                                    :wishlist-user-id="wishlistUserId"
                                    :is-wish-list-catalog="isWishListCatalog"
                            ></wishlist>

                            <div class="row mt-5" v-if="currentProduct.product_info_more">
                                <div class="col px-lg-5 display-info">
                                    <h4><b>Basic Details</b></h4>
                                    <ul>
                                        <li v-for="product_info_more in currentProduct.product_info_more"><a>{{product_info_more}}</a></li>
                                    </ul>
                                </div>
                            </div>

                        </div>
                    </div>
                </section>
            </div>
        </div>
    </div>
</template>
<script>
    import { Carousel, Slide } from 'vue-carousel';

    export default {
        components: {
            Carousel,
            Slide
        },
        props: {
            userId:{
                type: Number,
                default: null
            },
            wishlistUserId: {
                type: Number,
                default: null
            },
            product:{
                type:Array,
                default:null
            },

        },
        data() {
            return {
                isWishListCatalog: false,
                productsData:[],
                wishlistData:[],
                coverflowList:[],
                checkoutBool: false,
                currentView: "catalog",
                currentProduct: null,
                sortBy:"price_asc",
                totalProducts:0,
                categoryId:null
            }
        },
        mounted: function() {
            if(this.wishlistUserId && (this.wishlistUserId != this.userId)){
                this.isWishListCatalog = true;
            }

            if(this.wishlistUserId) {
                this.fetchWishlistData();
            }else{
                this.fetchCatalogData();
            }

            if(this.userId){
                this.fetchWishlistProductIds();
            }
        },
        methods: {
            sortAppliancesBy: function (sortType) {
                if(this.wishlistUserId) {
                    this.fetchWishlistData(null,sortType);
                }else{
                    this.fetchCatalogData(null,sortType);
                }
            },
            fetchCatalogData: function(pageNum = null, sortType = null){

                let productsUrl = '/api/get-product-data';
                let url= window.location.pathname;
                let categoryId = url.split('/');
                this.categoryId = categoryId[2]?categoryId[2]:this.categoryId;
                if(sortType){
                    productsUrl += "?orderBy="+sortType;
                }else {
                    productsUrl += "?orderBy="+this.sortBy;
                }

                if(pageNum){
                    productsUrl += "&page="+pageNum;
                }
                if(this.categoryId){
                    productsUrl += "&categoryId="+this.categoryId;
                }
                axios.get(productsUrl)
                    .then(response => {
                        this.productsData = response.data;
                        this.totalProducts = response.data.total?response.data.total:0;
                    });
            },
            fetchWishlistData: function(pageNum = null, sortType = null){
                let productsUrl = '/api/get-wishlist-product-data/'+this.wishlistUserId;
                if(sortType){
                    productsUrl += "?orderBy="+sortType;
                }else {
                    productsUrl += "?orderBy="+this.sortBy;
                }
                if(pageNum){
                    productsUrl += "&page="+pageNum;
                }
                axios.get(productsUrl)
                    .then(response => {
                        this.productsData = response.data;
                        this.totalProducts = response.data.total?response.data.total:0;
                    });
            },
            fetchWishlistProductIds: function(){
                let wishlistUrl = '/api/get-wishlist-data';
                let userId= this.userId;
                if(userId){
                    axios.get(wishlistUrl)
                        .then(response => {
                             response.data;
                            this.wishlistData = response.data;
                        });
                }

            },
            switchToProductDetail: function(product){
                this.currentProduct = product;
                this.createCoverFlowList();
                this.currentView = "productDetail";
            },
            switchToCatalog: function(){
                this.currentProduct = null;
                this.currentView = "catalog";
            },
            imageMouseOver: function(event) {
                event.target.style.transform = "scale(2)";
            },

            imageMouseMove: function(event) {
                var self = this;

                event.target.style.transform = "scale(2)";

                self.timeout = setTimeout(function() {
                    event.target.style.transformOrigin = ((event.pageX - event.target.getBoundingClientRect().left) / event.target.getBoundingClientRect().width) * 100 + '% ' + ((event.pageY - event.target.getBoundingClientRect().top - window.pageYOffset) / event.target.getBoundingClientRect().height) * 100 + "%";
                }, 50);

                self.mouseStop = setTimeout(function() {
                    event.target.style.transformOrigin = ((event.pageX - event.target.getBoundingClientRect().left) / event.target.getBoundingClientRect().width) * 100 + '% ' + ((event.pageY - event.target.getBoundingClientRect().top - window.pageYOffset) / event.target.getBoundingClientRect().height) * 100 + "%";
                }, 100);
            },

            imageMouseOut: function(event) {
                event.target.style.transform = "scale(1)";
            },
            createCoverFlowList: function () {
                let galleryImages = this.currentProduct.gallery_images;

                for(var i=0; i < galleryImages.length; i++){
                    this.coverflowList.push({'cover':galleryImages[i],'title':'-'})
                }
            }

        },
        computed: {
            isCatalogView: function(){
                return this.currentView == "catalog";
            },

            wishlistLinkLabel: function () {
                let wishlistLinkLabel= "My Wishlist";
                if(this.wishlistData && this.wishlistData.length > 0){
                    wishlistLinkLabel += " - "+this.wishlistData.length + " products"
                }
                return  wishlistLinkLabel;
            }
        }
    }
</script>
<style>
    .svg-icon-price-product{
        width : 1.1rem;
    }
    .svg-icon-prev-price-product{
        width : 0.9rem;
    }
    .product-details{
        background: #ffffff;
    }


</style>